# coding: utf-8

"""
    Antimatter Public API

    Interact with the Antimatter Cloud API

    The version of the OpenAPI document: 1.1.3
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Union
from pydantic import BaseModel, StrictBytes, StrictStr
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class GCPServiceAccountKeyInfo(BaseModel):
    """
    The GCP service account information and details required to use the  provided GCP hosted encryption key for cryptographic operations. 
    """ # noqa: E501
    service_account_credentials: Union[StrictBytes, StrictStr] = Field(description="The Google service account contents as a base64 encoded  JSON string. ", alias="serviceAccountCredentials")
    project_id: StrictStr = Field(description="The Google project ID.", alias="projectID")
    location: StrictStr = Field(description="Location of Google keyring.")
    keyring_id: StrictStr = Field(description="The Google keyring's ID at location.", alias="keyringID")
    key_id: StrictStr = Field(description="The key ID that should be used in the Google keyring.", alias="keyID")
    __properties: ClassVar[List[str]] = ["serviceAccountCredentials", "projectID", "location", "keyringID", "keyID"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of GCPServiceAccountKeyInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of GCPServiceAccountKeyInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "serviceAccountCredentials": obj.get("serviceAccountCredentials"),
            "projectID": obj.get("projectID"),
            "location": obj.get("location"),
            "keyringID": obj.get("keyringID"),
            "keyID": obj.get("keyID")
        })
        return _obj


